<?php
/*
Plugin Name: GPS Track on Google Maps
Plugin URI: http://www.snow-bridge.com/gps-track-on-google-maps/
Description: GPS Track is drawn on 'Google Maps'.
Version: 0.3.4
Author: snow-bridge
Author URI: http://www.snow-bridge.com/
*/

/*
Copyright 2010 Higuchi Yuta (email : yuta.freestyle@gmail.com)

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/



/*---------------------------------------------------------

    vOC̏ǗNX

---------------------------------------------------------*/
class GTOGM_Info {
	
	const OPTION_KEY = "gps-track-on-google-maps-v0.3_options";
	
	const ENABLE_DRAGGING = 1;
	const ENABLE_DOUBLE_CLICK_ZOOM = 2;
	const ENABLE_CONTINUOUS_ZOOM = 4;
	const ENABLE_SCROLL_WHEEL_ZOOM = 8;
	const DISABLE_GOOGLE_BAR = 16;
	
	const LARGE_MAP_CONTROL = 1;
	const MAP_TYPE_CONTROL = 2;
	const OVERVIEW_MAP_CONTROL = 4;
	const SCALE_CONTROL = 8;
	
	const G_NORMAL_MAP = 1;
	const G_HYBRID_MAP = 2;
	const G_SATELLITE_MAP = 4;
	const G_PHYSICAL_MAP = 8;
	const G_SATELLITE_3D_MAP = 16;
	
	private $options;
	
	private $plugin_name;
	
	//
	//  RXgN^
	//
	function __construct() {
		
		$this->plugin_name = 'GPS Track on Google Maps';
		
		$this->options = array();
		$this->options["google_maps_api_key"]  = "";
		$this->options["line_color"]           = "ff0000";
		$this->options["line_weight"]          = "3";
		$this->options["line_opacity"]         = "255";
		$this->options["map_type_control"]     = array(self::G_NORMAL_MAP, self::G_HYBRID_MAP, self::G_SATELLITE_MAP, self::G_PHYSICAL_MAP, self::G_SATELLITE_3D_MAP);
		$this->options["control"]              = array(self::LARGE_MAP_CONTROL, self::MAP_TYPE_CONTROL, self::OVERVIEW_MAP_CONTROL, self::SCALE_CONTROL);
		$this->options["map_type"]             = self::G_NORMAL_MAP;
		$this->options["map_width"]            = "480";
		$this->options["map_height"]           = "480";
		$this->options["kashmir"]              = 0;
		$this->options["open_google_maps"]     = 0;
		$this->options["zoom_level"]           = -1;
		$this->options["label_color"]          = "000000";
		$this->options["icon"]                 = "http://maps.google.co.jp/mapfiles/ms/icons/blue-dot.png";
		$this->options["icon_url"]             = "";
		
		// IvV݂ĂȂꍇ͒ǉi݂ꍇ͉Ȃj
		add_option(self::OPTION_KEY, $this->options);
		
		// IvVǂݍ
		$ops  = get_option(self::OPTION_KEY);
		
		// IvVlǉE폜ꂽꍇɑΉ悤
		foreach ($this->options as $key => $value) {
			// L[݂AftHgl㏑B
			if (array_key_exists($key, $ops)) {
				$this->options[$key] = $ops[$key];
			}
		}
		
	}
	
	//
	//  vOC擾
	//
	function get_plugin_name() {
		return $this->plugin_name;
	}
	
	//
	//  IvV擾
	//
	function get_option($name) {
		
		if (array_key_exists($name, $this->options)) {
			return $this->options[$name];
		} else {
			return false;
		}
	}
	
	//
	//  IvVXV
	//
	function set_option($name, $value) {
		
		// L[̑݃`FbN
		if (array_key_exists($name, $this->options)) {
			// L[̓͒l`FbN
			
			if ($name == "line_color" || $name == "label_color") {
				// 000000 --> FFFFFF
				if (preg_match("/^[0-9a-fA-F][0-9a-fA-F][0-9a-fA-F][0-9a-fA-F][0-9a-fA-F][0-9a-fA-F]$/", $value)) {
					$this->options[$name] = $value;
					update_option(self::OPTION_KEY, $this->options);
					return true;
				} else {
					return false;
				}
			} else if ($name == "line_weight") {
				// 0 --> 10
				if (preg_match("/(^[0-9]$)|(^10$)/", $value)) {
					$this->options[$name] = $value;
					update_option(self::OPTION_KEY, $this->options);
					return true;
				} else {
					return false;
				}
			} else if ($name == "line_opacity") {
				// 0 --> 255
				if (preg_match("/(^[0-9]$)|(^[1-9][0-9]$)|(^1[0-9][0-9]$)|(^2[0-5][0-5]$)/", $value)) {
					$this->options[$name] = $value;
					update_option(self::OPTION_KEY, $this->options);
					return true;
				} else {
					return false;
				}
			} else if ($name == "map_width" || $name == "map_height") {
				// 0ȏ̐
				if (preg_match("/(^[0-9]$)|(^[1-9][0-9]+$)/", $value)) {
					$this->options[$name] = $value;
					update_option(self::OPTION_KEY, $this->options);
					return true;
				} else {
					return false;
				}
			} else {
				$this->options[$name] = $value;
				update_option(self::OPTION_KEY, $this->options);
				return true;
			}
		} else {
			return false;
		}
	}
	
}

// IvVݒ
require('setting.php');

// V[gR[hݒ
//require('insertmap.php');

require('shortcode.php');

// 
//require('customfield.php');

// GPXAbv[hKMLt@C쐬
require('makekml.php');



$plugin_basename = plugin_basename(__FILE__);
// vOCLɎs
add_action( 'activate_' . $plugin_basename, 'activate_gtogm_plugin' );
function activate_gtogm_plugin() {
	// delete_option(GTOGM_Info::OPTION_KEY);
}
// vOCɎs
// add_action( 'deactivate_' . $plugin_basename, 'deactivate_gtogm_plugin' );




$gtogm_makekml = new GTOGM_MakeKML();

$gtogm_shortcode = new GTOGM_ShortCode();


//if (version_compare($wp_version, '2.7', '>=') && version_compare(PHP_VERSION, '5.0.0', '>=')) {
	
//	if (preg_match("/post.php|post-new.php|page.php|page-new.php/", $_SERVER["REQUEST_URI"]) == 1) {
		// 
		//$gtogm_customfield = new GTOGM_CustomField();
//	}
	
	// Lւ̒n}}CX^X
//	$gtogm_shortcode = new GTOGM_InsertMap();
	
	// IvVݒʃCX^X
	$gtogm_setting = new GTOGM_Setting();

	
	// ۉijΉ
	load_plugin_textdomain("gtogm", false, dirname(plugin_basename(__FILE__)));
//}
?>